
import sys

#class AbsInterface :


#class AbsDialog :


class AbsWizard :
	def __init__(self, name) : 
		self.screens = []     

	def setValue(self, field, value) :
		for screen in self.screens :
			if screen.setValue(field, value) :
				return

	def getValue(self, field) :
		for screen in self.screens :
			v = screen.getValue(field)
			if v != None :
				return v
		return None

	def setEnabled(self, field, enabled) :
		for screen in self.screens :
			if screen.setEnabled(field, enabled) :
				return

	def isEnabled(self, field) :
		for screen in self.screens :
			v = screen.isEnabled(field)
			if v != None :
				return v
		return None


class AbsScreen :
	def __init__(self) :
		self.fields = {}   
	
	def setValue(self, field, value) :
		if self.fields.has_key(field) :
			self.fields[field].setValue(value)
			return 1
		else :
			return 0

	def getValue(self, field) :
		if self.fields.has_key(field) :
			return self.fields[field].getValue()
		else :
			return None

	def setEnabled(self, field, enabled) :
		if self.fields.has_key(field) :
			self.fields[field].setEnabled(enabled)
			return 1
		else :
			return 0

	def isEnabled(self, field) :
		if self.fields.has_key(field) :
			return self.fields[field].isEnabled()
		else :
			return None


class AbsTranslator :
	def __init__(self, translationsFile = '') :
		self.language = "C"
		strings = {}
		lines = open(translationsFile).readlines()
		current = ""
		for line in lines :
			colon = line.find("::")
			if colon != -1 :
				lang = line[:colon].strip()
				string = line[colon+2:].strip()
				if lang == "C" :
					current = string
				else :
					strings[lang+"::"+current] = string
		self.strings = strings

	def setLanguage(self, lang) :
		self.language = lang.strip()

	def tr(self,s) :
		key = self.language + "::" + s.strip()
		if self.strings.has_key(key) :
			return self.strings[key]
		else :
			return s
